LeetCode 分类刷题:1669. 合并两个链表

题目

给你两个链表 list1 和 list2 ,它们包含的元素分别为 n 个和 m 个。

请你将 list1 中下标从 a 到 b 的全部节点都删除,并将list2 接在被删除节点的位置。

下图中蓝色边和节点展示了操作后的结果:

请你返回结果链表的头指针。

提示:

  • 3 <= list1.length <=
  • 1 <= a <= b < list1.length - 1
  • 1 <= list2.length <=

解析

我的思路:

// 第一次快指针从头走(b-a+2)步

// 第二次快指针继续走a-1步,慢指针从头走a-1步

// 修改快慢指针分别指向链表2的尾和头

官方题解思路:

// 第一次慢指针从头走a-1步

// 让快指针指向慢指针的位置,再走(b-a+2)步

// 慢指针的next指向list2(头节点)

// list2移动到链表2的尾节点

// 快指针的next指向list2(尾节点)

对比可以发现官方题解有几处巧思,比如:直接让快指针指向慢指针再走(b-a+2)步;确定快慢指针的位置后,先让慢指针的下个节点链接上链表2,再将链表2的头指针用于移动,寻找尾节点,避免了创建新的指针变量。

答案

我的答案:

javascript 复制代码
/**
 * Definition for singly-linked list.
 * function ListNode(val, next) {
 *     this.val = (val===undefined ? 0 : val)
 *     this.next = (next===undefined ? null : next)
 * }
 */
/**
 * @param {ListNode} list1
 * @param {number} a
 * @param {number} b
 * @param {ListNode} list2
 * @return {ListNode}
 */
var mergeInBetween = function(list1, a, b, list2) {
    // 第一次快指针走(b-a+2)步
    // 第二次快指针走a-1步,慢指针走a-1步
    // 修改快慢指针分别指向链表2的尾和头
    let slow = list1;
    let fast = list1;
    for(let i = 0; i < b - a + 2; i++) {
        fast = fast.next;
    }
    for(let i = 0; i < a - 1; i++) {
        fast = fast.next;
        slow = slow.next;
    }
    let tail2 = list2;
    while(tail2.next) {
        tail2 = tail2.next;
    }
    slow.next = list2;
    tail2.next = fast;
    return list1;
};

官方题解:

javascript 复制代码
var mergeInBetween = function(list1, a, b, list2) {
    let preA = list1;
    for (let i = 0; i < a - 1; i++) {
        preA = preA.next;
    }
    let preB = preA;
    for (let i = 0; i < b - a + 2; i++) {
        preB = preB.next;
    }
    preA.next = list2;
    while (list2.next) {
        list2 = list2.next;
    }
    list2.next = preB;
    return list1;
};

// 作者:力扣官方题解
// 链接:https://leetcode.cn/problems/merge-in-between-linked-lists/solutions/2079499/he-bing-liang-ge-lian-biao-by-leetcode-s-alt8/
// 来源:力扣(LeetCode)
// 著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。

复杂度分析

时间复杂度:O(n+m),其中 n 是 list1​ 的长度,m 是 list2​ 的长度。

空间复杂度:O(1)

我觉得时间复杂度是O(b + m),但是官方题解给的是O(n+m)?

  • O(b + m):强调操作与b的直接关系。
  • O(n + m):强调最坏情况下与链表1长度的关系。

更规范的表述是O(n + m),因为算法分析通常以输入规模的完整上限为准。

相关推荐
hold?fish:palm2 小时前
40 二叉树的直径
c++·leetcode
鶴哥只手遮天3 小时前
jQuery 4.0 源码架构与工程实践-第 10 章 尺寸、几何与显隐
前端·javascript·jquery
guo_wen_qiang3 小时前
二叉树的层序遍历-使用双端队列Deque
算法·leetcode·1024程序员节
爱读书的小胖4 小时前
LeetCode 55 跳跃游戏 C 语言解题分析
c语言·数据结构·算法·leetcode·1024程序员节
Navigator_Z5 小时前
LeetCode //C - 1300. Sum of Mutated Array Closest to Target
c语言·算法·leetcode
米米商聊5 小时前
图标能点,按钮就可用了吗?键盘、名称与收藏状态
前端·javascript
凯瑟琳.奥古斯特6 小时前
力扣1016高效解法:剪枝优化技巧
开发语言·c++·算法·leetcode·职场和发展
技术小甜甜7 小时前
【Cursor】Skill 被标黄色警告,怎么改成合格的 SKILL.md
开发语言·javascript·ai编程·cursor·1024程序员节·ai agent·skills
qz_Serene7 小时前
练习算法题:双指针 -cpp
c++·算法·leetcode·1024程序员节
Nuanyt7 小时前
Hot 100 刷题笔记 · 数组与哈希专题(3 题)
java·笔记·算法·leetcode·哈希算法·1024程序员节